routes/admin.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::group(['middleware' => ['auth']], function () {    

    Route::resource('sellers', 'Admin\SellerController');

    Route::resource('raffles', 'Admin\RaffleController');
    Route::get('raffle/{id}/clients', 'Admin\ClientController@index')->name('raffle.clients.index');
    Route::get('raffle/{id}/sellers', 'Admin\RaffleController@sellersIndex')->name('raffle.sellers.index');
    Route::post('raffle/{id}/upload/image', 'Admin\RaffleController@uploadImage')->name('raffle.upload.image');
    Route::get('raffle/{id}/clients/returns', 'Admin\ClientController@returns')->name('raffle.clients.returns');
});

routes/web.php
<?php

use Illuminate\Support\Facades\Route;

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('login', 'Auth\LoginController@showLoginForm')->name('login');
Route::post('login', 'Auth\LoginController@login');
Route::post('logout', 'Auth\LoginController@logout')->name('logout');

Route::group(['middleware' => ['auth']], function () {    
    Route::get('/', 'Admin\HomeController@index')->name('home');
    //Raffles generate
    Route::get('raffles/generate/unique/link/client', 'RaffleController@generateUniqueLink')->name('raffles.generate.unique.link.client');
    Route::get('raffles/{id}/generate/lottery', 'RaffleController@generateLottery')->name('raffles.generate.lottery');
});

app/Models/Seller.php
<?php

namespace App\Models;

class Seller extends Model
{
    protected $fillable = [
        'names', 'commission'
    ];

    public $rules = [
        'names' => 'required|max:200',        
        'commission' => 'required|integer'
    ];

    public function scopeWithCreator($query) {
        return $query->where('created_by', auth()->id());
    }

    public function links() {
        return $this->hasMany(Link::class);
    }

    public function getTotalCommissionAttribute() {        
        $count = $this->links()->whereNotNull('client_id')->count();              
        return ($count * $this->commission);
    }
}

app/Http/Controllers/Admin/SellerController.php
<?php

namespace App\Http\Controllers\Admin;

use Illuminate\Http\Request;
class SellerController extends Controller
{
    protected $resourceName = 'sellers';
    protected $resourceClass = \App\Models\Seller::class;
    
    protected function afterSave($item = null, $request) {
        if ($item && is_null($item->getOriginal('created_by'))) {
            $item->created_by = auth()->id();
            $item->save();
        }
    }
}

app/Http/Controllers/Api/SellerController.php
<?php

namespace App\Http\Controllers\Api;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use DataTables;
class SellerController extends Controller
{
    protected $resourceName = 'sellers';

    protected $resourceClass = \App\Models\Seller::class;
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct() {}

    public function datatables() {
        $items = $this->resourceClass::withCreator()->get();                
        $datatable = DataTables::collection($items);
        $this->columns($datatable);
        $datatable->rawColumns(['actions', 'name']);
        return $datatable->make(true);
    }

    private function columns(&$datatable) {
        $datatable->editColumn('commission', function ($item) {
            return '$' . number_format($item->commission);
        })->editColumn('actions', function ($item) {
            return view('common.actions', [
                "edit" => true,
                "routeEdit" => route("admin.$this->resourceName.edit", ['seller' => $item->id]),
            ])->render();
        }); 
    }

    public function paidOutUpdate(Request $request, $id, $seller_id) {
        if ($raffleSeller = \App\Models\RaffleSeller::where(['raffle_id' => $id, 'seller_id' => $seller_id])->first()) {
            $raffleSeller->paid_out = $request->paid_out;
            $raffleSeller->save();
            return response()->json(["message" => "ok"]);
        }
        return response()->json(["error" => true, "message" => __('common.errors.error_raffle_not_found')]);
    }
}

resources/views/admin/sellers/form.blade.php
<div class="row">
    @include('common.input', [
        "id" => "names",
        "required" => true,
        "clas" => "col-md-6",
        "label" => __('common.inputs.full_name'),
        "value" => (isset($item->names) ? $item->names : old('names'))
    ])
    @include('common.input', [
        "id" => "commission",
        "required" => true,
        "clas" => "col-md-6",
        "label" => __('common.inputs.commission'),
        "value" => (isset($item->commission) ? $item->commission : old('commission')),
        "type" => "number"
    ])
</div>

resources/views/admin/sellers/index.blade.php
@extends('layouts.app')

@section('content')
    @parent
    <x-content>
        <x-slot name="title">@lang('common.administration', ['model' => __('common.menu.sellers')])</x-slot>
        <div class="row py-4">
            <div class="col-md-12">
                <a href="{{ route('admin.sellers.create') }}" class="btn btn-outline-primary float-right"><i class="fas fa-plus"></i> @lang('common.add')</a>
                <a href="{{ route('home') }}" class="btn btn-outline-dark"><i class="fas fa-long-arrow-alt-left"></i> @lang('common.cancel')</a>
            </div>
        </div>
        <div class="row">
            <div class="col-md-12">
                @include('common.table', [
                    "resource" => "sellers",
                    "headers" => [
                        "names" => __('common.inputs.full_name'),
                        "commission" => __('common.inputs.commission'),
                        "actions" => __('common.inputs.actions'),
                    ],
                    "url" => route('api.sellers.datatables')
                ])
            </div>
        </div>
    </x-content>
@endsection

resources/views/admin/sellers/item.blade.php
@extends('layouts.app')

@section('content')
    @parent
    <x-content>
        <x-slot name="title">@lang('common.' . (isset($item) ? 'edit' : 'add')) @lang('common.seller')</x-slot>
        <div class="row py-4">
            <div class="col-md-12">
                @component('components.form', [
                    "item" => (isset($item) ? $item : null),
                    "resource" => "sellers",
                    "back" => route('admin.sellers.index'),
                    "updateResource" => "seller"
                ])
                    @include('admin.sellers.form', ['item' => (isset($item) ? $item : null)])
                @endcomponent
            </div>
        </div>        
    </x-content>
@endsection